<?php
session_start();

if (!isset($_SESSION['codigo_empresa'])) {
    header("Location: inicio.php");
    exit();
}

$servername = "localhost";
$username = "wp_usertomp";
$password = "p3%Pz14YRM@";
$dbname = "tompedidos";

// Crear la conexión a MySQL
$conn = new mysqli($servername, $username, $password, $dbname);

// Verificar la conexión
if ($conn->connect_error) {
    die("Connection failed: " . $conn->connect_error);
}

$empresa = $_SESSION['codigo_empresa'];
$sql_vendedores = "SELECT * FROM vendedor WHERE empresa = '$empresa'";
$result_vendedores = $conn->query($sql_vendedores);

$vendedor_id = isset($_GET['vendedor_id']) ? $_GET['vendedor_id'] : "";
$start_date = isset($_GET['start_date']) ? $_GET['start_date'] : "";
$end_date = isset($_GET['end_date']) ? $_GET['end_date'] : "";

// Construir la consulta SQL para las ubicaciones
$sql_locations = "SELECT * FROM locations WHERE empresa = '$empresa' and tipo = 'P' ";

// Filtrar por vendedor si está presente
if (!empty($vendedor_id) && $vendedor_id != "0") {
    $sql_locations .= " AND vendedor = '$vendedor_id'";
}

// Filtrar por rango de fechas si están presentes
if (!empty($start_date) && !empty($end_date)) {
    $sql_locations .= " AND DATE(timestamp) BETWEEN '$start_date' AND '$end_date'";
}
$sql_locations .= " order by id asc  ";

$result_locations = $conn->query($sql_locations);

$locations = [];
if ($result_locations->num_rows > 0) {
    while ($row = $result_locations->fetch_assoc()) {
        $locations[] = $row;
    }
}

$conn->close();
?>

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Mapa de Rutas</title>
    <link rel="stylesheet" href="https://unpkg.com/leaflet@1.7.1/dist/leaflet.css" />
    <link rel="stylesheet" href="https://unpkg.com/leaflet-routing-machine@3.2.12/dist/leaflet-routing-machine.css" />
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0-beta3/css/all.min.css">
    
    <style>
        /* Ajuste del espaciado para compensar el menú fijo */
        body {
            padding-top: 56px;
            background-color: #f8f9fa;
        }

        /* Estilo del mapa */
        #map {
            height: 600px;
            width: 100%;
        }

        /* Para animar la visibilidad del contenedor */
        .search-container {
            transition: max-height 0.5s ease-in-out;
            overflow: hidden;
        }

        .navbar-nav .nav-link {
            color: white !important;
            padding: 10px 15px;
            border-radius: 10px;
        }

        .navbar-nav .nav-link:hover {
            background-color: #007bff;
        }

        .navbar-nav .logout-btn {
            background-color: #dc3545;
            color: white !important;
            border-radius: 20px;
        }

        .navbar-nav .logout-btn:hover {
            background-color: #bd2130;
        }

        .navbar-collapse {
            transition: max-height 0.5s ease-in-out;
        }

        .logout-btn {
            width: 100%;
        }
		
        .search-container {
            overflow: hidden;
            transition: height 0.5s ease;
            height: auto; 
        }
        .hidden {
            height: 0;
        }

        /* Estilo para la flecha */
        .arrow-button {
			position: relative;
			left: 50%;
			transform: translateX(-50%);
			margin-top: 10px; /* Espaciado entre el div de búsqueda y la flecha */
			background: transparent;
			border: none;
			cursor: pointer;
			z-index: 1000;
			opacity: 0.8;
			transition: top 0.3s, opacity 0.3s;
		}

        .arrow-button.hidden {
			position: fixed;
			top: 60px; /* Debajo del menú fijo */
			left: 50%;
			transform: translateX(-50%);
			opacity: 0.5;
		}

        .arrow-button:hover {
			opacity: 1;
		}
    </style>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-dark bg-primary fixed-top">
        <div class="container-fluid">
            <a class="navbar-brand" href="menu.php">Menú Principal</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarNav">
                <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                    <li class="nav-item">
                        <a class="nav-link" href="menu.php">Ruta del Vendedor</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="map3.php">Pedidos del Vendedor</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="mapa.php">Vendedor en Tiempo Real</a>
                    </li>
                </ul>
                <ul class="navbar-nav ms-auto mb-2 mb-lg-0">
                    <li class="nav-item">
                        <a class="nav-link logout-btn" href="cerrar.php">Cerrar Sesión</a>
                    </li>
                </ul>
            </div>
        </div>
    </nav>

    <div id="searchContainer" class="container mt-5 search-container">
        <form method="GET" action="">
            <div class="mb-3">
                <label for="vendedor_id" class="form-label">Seleccionar Vendedor</label>
                <select id="vendedor_id" name="vendedor_id" class="form-select">                    
                    <?php while ($vendedor = $result_vendedores->fetch_assoc()): ?>
                        <option value="<?php echo $vendedor['codigo']; ?>" 
                            <?php echo $vendedor_id == $vendedor['codigo'] ? 'selected' : ''; ?>>
                            <?php echo $vendedor['nombre']; ?>
                        </option>
                    <?php endwhile; ?>
                </select>
            </div>
            <div class="mb-3">
                <label for="start_date" class="form-label">Fecha de Inicio</label>
                <input type="date" id="start_date" name="start_date" class="form-control" value="<?php echo isset($_GET['start_date']) ? $_GET['start_date'] : ''; ?>">
            </div>
            <div class="mb-3">
                <label for="end_date" class="form-label">Fecha de Fin</label>
                <input type="date" id="end_date" name="end_date" class="form-control" value="<?php echo isset($_GET['end_date']) ? $_GET['end_date'] : ''; ?>">
            </div>
			<div class="form-check form-switch mb-3">
				<input class="form-check-input" type="checkbox" id="showClientLocation" name="showClientLocation">
				<label class="form-check-label" for="showClientLocation">Mostrar Ubicacion del Cliente</label>
			</div>

            <button type="button" id="filter-btn" class="btn btn-primary">Filtrar</button>
        </form>
    </div>

    <button id="toggle-search" class="arrow-button">
        <i class="fas fa-chevron-up"></i>
    </button>
    <div id="map"></div>

    <script src="https://unpkg.com/leaflet@1.7.1/dist/leaflet.js"></script>
    <script src="https://unpkg.com/leaflet-routing-machine@3.2.12/dist/leaflet-routing-machine.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/js/bootstrap.bundle.min.js"></script>
    <script>
        // Crear el mapa centrado en una ubicación predeterminada
        var map = L.map('map').setView([0, 0], 2);

        // Añadir el tile de OpenStreetMap
        L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            maxZoom: 19,
            attribution: '© OpenStreetMap'
        }).addTo(map);

        // Array PHP que contiene las ubicaciones, ya ordenadas por timestamp
        var locations = <?php echo json_encode($locations); ?>;

        // Definir los iconos personalizados para el inicio y el final
        var startIcon = L.icon({
            iconUrl: 'https://icons.iconarchive.com/icons/icons-land/vista-map-markers/48/Map-Marker-Push-Pin-1-Chartreuse-icon.png',
            iconSize: [41, 41],
            iconAnchor: [20, 41],
            popupAnchor: [1, -34]
        });

        var endIcon = L.icon({
            iconUrl: 'https://icons.iconarchive.com/icons/icons-land/vista-map-markers/48/Map-Marker-Ball-Pink-icon.png',
            iconSize: [41, 41],
            iconAnchor: [20, 41],
            popupAnchor: [1, -34]
        });

        var pIcon = L.icon({
            iconUrl: 'https://icons.iconarchive.com/icons/gartoon-team/gartoon-misc/128/Gtk-Edit-icon.png',
            iconSize: [41, 41],
            iconAnchor: [20, 41],
            popupAnchor: [1, -34]
        });

        // Si hay más de un punto, creamos la ruta
        if (locations.length > 1) {
            var waypoints = locations.map(function(location) {
                return L.latLng(parseFloat(location.latitude), parseFloat(location.longitude));
            });

            L.Routing.control({
                waypoints: waypoints,
                router: L.Routing.osrmv1({
                    serviceUrl: 'https://router.project-osrm.org/route/v1'
                }),
                createMarker: function(i, waypoint, n) {
                    var location = locations[i];
                    var timestamp = new Date(location.timestamp).toLocaleString();
                    var tipo = location.tipo;

                    if (i === 0) {
                        return L.marker(waypoint.latLng, { icon: startIcon })
                            .bindPopup('Inicio<br>Latitud: ' + waypoint.latLng.lat + '<br>Longitud: ' + waypoint.latLng.lng + '<br>Fecha y Hora: ' + timestamp);
                    } else if (i === n - 1) {
                        return L.marker(waypoint.latLng, { icon: endIcon })
                            .bindPopup('Final<br>Latitud: ' + waypoint.latLng.lat + '<br>Longitud: ' + waypoint.latLng.lng + '<br>Fecha y Hora: ' + timestamp);
                    } else {
                        if (tipo === 'P') {
                            return L.marker(waypoint.latLng, { icon: pIcon })
                                .bindPopup('Pedido<br>Latitud: ' + waypoint.latLng.lat + '<br>Longitud: ' + waypoint.latLng.lng + '<br>Fecha y Hora: ' + timestamp);
                        } else {
                            return L.marker(waypoint.latLng)
                                .bindPopup('Latitud: ' + waypoint.latLng.lat + '<br>Longitud: ' + waypoint.latLng.lng + '<br>Fecha y Hora: ' + timestamp);
                        }
                    }
                }
            }).addTo(map);

            map.fitBounds(L.latLngBounds(waypoints));
        } else {
            alert('No Existen datos, revise el rango de busqueda por Favor');
        }

        document.addEventListener("DOMContentLoaded", function () {
			const toggleButton = document.getElementById("toggle-search");
			const searchContainer = document.getElementById("searchContainer");

			toggleButton.addEventListener("click", function () {
				searchContainer.classList.toggle("hidden");

				// Cambiar la flecha y la posición
				if (searchContainer.classList.contains("hidden")) {
					toggleButton.classList.add("hidden");
					toggleButton.innerHTML = '<i class="fas fa-chevron-down"></i>';
				} else {
					toggleButton.classList.remove("hidden");
					toggleButton.innerHTML = '<i class="fas fa-chevron-up"></i>';
				}
			});
		});
		
		document.addEventListener("DOMContentLoaded", function () {
			const filterButton = document.getElementById("filter-btn");
			const startDateInput = document.getElementById("start_date");
			const endDateInput = document.getElementById("end_date");

			filterButton.addEventListener("click", function () {
				const startDate = new Date(startDateInput.value);
				const endDate = new Date(endDateInput.value);

				// Validar si ambas fechas están seleccionadas
				if (!startDateInput.value || !endDateInput.value) {
					alert("Por favor, seleccione ambas fechas antes de filtrar.");
					return;
				}

				// Validar que la fecha inicial sea menor o igual a la fecha final
				if (startDate > endDate) {
					alert("La fecha de inicio debe ser menor o igual a la fecha de fin.");
					return;
				}

				// Si las fechas son válidas, envía el formulario
				document.querySelector("form").submit();
			});
		});


    </script>
</body>
</html>
